#if defined _file_uploader_included_
	#endinput
#endif
#define _file_uploader_included_

/**
 * Add a field for attachment.
 *
 * @param   bStatus     Status upload
 * @param   iValue      Value passed from caller
 * @param   szError     Error uploading
 *
 * @return  void
 */
typedef OnFileUploaded = function void (bool bStatus, any iValue, const char[] szError);

/**
 * Upload file to remote host.
 *
 * @param szDomain			URI (https://example.com)
 * @param szPath			Script path (upload.php)
 * @param szToken			Access token
 * @param szFilePath		File to read from
 * @param szSavePath		Relative path to save path
 * @param szSaveFileName	File name to save
 * @param fCallback			A function to use as a callback when the upload has finished.
 * @param iValue			Optional value to pass to the callback function.
 *
 * @return  void
 * @throws  Error, if file doesn't exists.
 */
native void UploadFile(
	const char[] szDomain, 
	const char[] szPath,  
	const char[] szToken, 
	const char[] szFilePath, 
	const char[] szSavePath = NULL_STRING, 
	const char[] szSaveFileName = NULL_STRING,
	OnFileUploaded fCallback, 
	any iValue = 0
);

public SharedPlugin __pl_file_uploader = {
	name = "file_uploader",
	file = "file_uploader.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_file_uploader_SetNTVOptional()
{
	MarkNativeAsOptional("UploadFile");
}
#endif
