#if defined _raising_teammate_included
	#endinput
#endif
#define _raising_teammate_included

/**
 * Gets is raises player.
 *
 * @param iActivator    Activator index.
 *
 * @return              Is raises.
 */
native bool IsPlayerRaises(int iActivator);

/**
 * Stops player raises.
 *
 * @param iActivator    Activator index.
 *
 * @noreturn
 */
native void StopPlayerRaises(int iActivator);

/**
 * Called when player raising teammate.
 *
 * @param iClient       Client index.
 * @param iActivator    Activator index.
 * @param iRagdoll      Ragdoll from the client index.
 * @param iTime         Time in seconds how much to raise. Can change.
 *
 * @return              Plugin_Handled for stop the change.
 */
forward Action OnPlayerRaisingPre(int iClient, int iActivator, int iRagdoll, int &iTime);

/**
 * Called when player raising teammate, after OnPlayerRaisingPre.
 *
 * @param iClient       Client index.
 * @param iActivator    Activator index.
 * @param iRagdoll      Ragdoll from the client Ragdoll index.
 * @param iTime         Time in seconds how much to raise.
 *
 * @noreturn
 */
forward void OnPlayerRaisingPost(int iClient, int iActivator, int iRagdoll, int iTime);

/**
 * Called when player stop raising teammate.
 *
 * @param iActivator    Activator index.
 *
 * @noreturn
 */
forward void OnPlayerStopRaising(int iActivator);

/**
 * Called when player raised teammate.
 *
 * @param iClient       Client index.
 * @param iActivator    Activator index.
 *
 * @noreturn
 */
forward void OnPlayerRaised(int iClient, int iActivator);



public SharedPlugin __pl_raising_teammate =
{
	name = "raising_teammate",
	file = "raising_teammate.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_restrict_SetNTVOptional()
{
	MarkNativeAsOptional("IsPlayerRaises");
	MarkNativeAsOptional("StopPlayerRaises");
}
#endif